#include "winstuff.h"
#include <windows.h>
#include "myjoy.h"
#include <stdio.h>
#include <f:\directx\sdk\inc\dinput.h>
#include "d_event.h"
char MyS[256];
JoyBias_t JoyBias;
/****************************************************************************
 *
 *      DIInit
 *
 *      Initialize the DirectInput variables.
 *
 ****************************************************************************/
int JoyActive;      //don't check it if it doesn't exist.
JOYINFOEX JoyStats;
JOYCAPS JoyCaps;


BOOL DIInitJoy(){
    JoyActive = joyGetNumDevs();
    if(JoyActive){
        JoyStats.dwSize = sizeof(JOYINFOEX);
        joyGetDevCaps(0,&JoyCaps,sizeof(JOYCAPS));
        JoyFixBias();
    }
}

int JoyRead(int joy){
    int res;
    JoyStats.dwFlags=JOY_RETURNALL;
    res = joyGetPosEx( joy, &JoyStats);
    return res;
}

void JoyFixBias(void){
    JoyBias.X = (JoyCaps.wXmin+JoyCaps.wXmax)/2;
    JoyBias.Y = (JoyCaps.wYmin+JoyCaps.wYmax)/2;
    JoyBias.Z = (JoyCaps.wZmin+JoyCaps.wZmax)/2;
    JoyBias.R = (JoyCaps.wRmin+JoyCaps.wRmax)/2;
    JoyBias.U = (JoyCaps.wUmin+JoyCaps.wUmax)/2;
    JoyBias.V = (JoyCaps.wVmin+JoyCaps.wVmax)/2;
}

void DI_JoyCheck(void){
    event_t joyevent;
    joyevent.type = ev_joystick;
    joyevent.data1 = 0;//clear it.
    joyevent.data2 = 0;
    joyevent.data3 = 0;
    if(JoyActive){//need a real joystick
        if(JoyRead(0)){
            JoyActive=0;
            return;
        }
        //Print("Hi Joy read");
        joyevent.data1 = JoyStats.dwButtons;
        joyevent.data2 = JoyStats.dwXpos-JoyBias.X;
        //Doom thinks it is digital.  ugh.
        if(joyevent.data2>JoyBias.X/2){
            joyevent.data2 = 1;
        }
        else if(joyevent.data2<-JoyBias.X/2){
            joyevent.data2 = -1;
        }
        else
            joyevent.data2 = 0;

        joyevent.data3 = JoyStats.dwYpos-JoyBias.Y;
        if(joyevent.data3>JoyBias.Y/2){
            joyevent.data3 = 1;
        }
        else if(joyevent.data3<-JoyBias.Y/2){
            joyevent.data3 = -1;
        }
        else
            joyevent.data3 = 0;
       	D_PostEvent(&joyevent);
    }
}