// Emacs style mode select   -*- C++ -*-
//-----------------------------------------------------------------------------
//
// $Id:$
//
// Copyright (C) 1993-1996 by id Software, Inc.
//
// This source is available for distribution and/or modification
// only under the terms of the DOOM Source Code License as
// published by id Software. All rights reserved.
//
// The source is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// FITNESS FOR A PARTICULAR PURPOSE. See the DOOM Source Code License
// for more details.
//
// $Log:$
//
// DESCRIPTION:
//	Direct Sound Interface to Doom.  IE Doom's sound stuff calls
//  my sound stuff.
//	Kept as a sample, DOOM2 sounds.
//
//-----------------------------------------------------------------------------


static const char
rcsid[] = "$Id: sounds.c,v 1.3 1997/01/29 22:40:44 b1 Exp $";

#include "winstuff.h"
#include "doomtype.h"
#include "sounds.h"
#include "F:\directx\sdk\inc\dsound.h"

//
// Information about all the music
//

musicinfo_t S_music[] =
{
    { 0 },
    { "e1m1", 0 },
    { "e1m2", 0 },
    { "e1m3", 0 },
    { "e1m4", 0 },
    { "e1m5", 0 },
    { "e1m6", 0 },
    { "e1m7", 0 },
    { "e1m8", 0 },
    { "e1m9", 0 },
    { "e2m1", 0 },
    { "e2m2", 0 },
    { "e2m3", 0 },
    { "e2m4", 0 },
    { "e2m5", 0 },
    { "e2m6", 0 },
    { "e2m7", 0 },
    { "e2m8", 0 },
    { "e2m9", 0 },
    { "e3m1", 0 },
    { "e3m2", 0 },
    { "e3m3", 0 },
    { "e3m4", 0 },
    { "e3m5", 0 },
    { "e3m6", 0 },
    { "e3m7", 0 },
    { "e3m8", 0 },
    { "e3m9", 0 },
    { "inter", 0 },
    { "intro", 0 },
    { "bunny", 0 },
    { "victor", 0 },
    { "introa", 0 },
    { "runnin", 0 },
    { "stalks", 0 },
    { "countd", 0 },
    { "betwee", 0 },
    { "doom", 0 },
    { "the_da", 0 },
    { "shawn", 0 },
    { "ddtblu", 0 },
    { "in_cit", 0 },
    { "dead", 0 },
    { "stlks2", 0 },
    { "theda2", 0 },
    { "doom2", 0 },
    { "ddtbl2", 0 },
    { "runni2", 0 },
    { "dead2", 0 },
    { "stlks3", 0 },
    { "romero", 0 },
    { "shawn2", 0 },
    { "messag", 0 },
    { "count2", 0 },
    { "ddtbl3", 0 },
    { "ampie", 0 },
    { "theda3", 0 },
    { "adrian", 0 },
    { "messg2", 0 },
    { "romer2", 0 },
    { "tense", 0 },
    { "shawn3", 0 },
    { "openin", 0 },
    { "evil", 0 },
    { "ultima", 0 },
    { "read_m", 0 },
    { "dm2ttl", 0 },
    { "dm2int", 0 }
};


//
// Information about all the sfx
//

sfxinfo_t S_sfx[] =
{
  // S_sfx[0] needs to be a dummy for odd reasons.
  { "none", false,  0, 0, -1, -1, 0 },

  { "pistol", false, 64, 0, -1, -1, 0 },
  { "shotgn", false, 64, 0, -1, -1, 0 },
  { "sgcock", false, 64, 0, -1, -1, 0 },
  { "dshtgn", false, 64, 0, -1, -1, 0 },
  { "dbopn", false, 64, 0, -1, -1, 0 },
  { "dbcls", false, 64, 0, -1, -1, 0 },
  { "dbload", false, 64, 0, -1, -1, 0 },
  { "plasma", false, 64, 0, -1, -1, 0 },
  { "bfg", false, 64, 0, -1, -1, 0 },
  { "sawup", false, 64, 0, -1, -1, 0 },
  { "sawidl", false, 118, 0, -1, -1, 0 },
  { "sawful", false, 64, 0, -1, -1, 0 },
  { "sawhit", false, 64, 0, -1, -1, 0 },
  { "rlaunc", false, 64, 0, -1, -1, 0 },
  { "rxplod", false, 70, 0, -1, -1, 0 },
  { "firsht", false, 70, 0, -1, -1, 0 },
  { "firxpl", false, 70, 0, -1, -1, 0 },
  { "pstart", false, 100, 0, -1, -1, 0 },
  { "pstop", false, 100, 0, -1, -1, 0 },
  { "doropn", false, 100, 0, -1, -1, 0 },
  { "dorcls", false, 100, 0, -1, -1, 0 },
  { "stnmov", false, 119, 0, -1, -1, 0 },
  { "swtchn", false, 78, 0, -1, -1, 0 },
  { "swtchx", false, 78, 0, -1, -1, 0 },
  { "plpain", false, 96, 0, -1, -1, 0 },
  { "dmpain", false, 96, 0, -1, -1, 0 },
  { "popain", false, 96, 0, -1, -1, 0 },
  { "vipain", false, 96, 0, -1, -1, 0 },
  { "mnpain", false, 96, 0, -1, -1, 0 },
  { "pepain", false, 96, 0, -1, -1, 0 },
  { "slop", false, 78, 0, -1, -1, 0 },
  { "itemup", true, 78, 0, -1, -1, 0 },
  { "wpnup", true, 78, 0, -1, -1, 0 },
  { "oof", false, 96, 0, -1, -1, 0 },
  { "telept", false, 32, 0, -1, -1, 0 },
  { "posit1", true, 98, 0, -1, -1, 0 },
  { "posit2", true, 98, 0, -1, -1, 0 },
  { "posit3", true, 98, 0, -1, -1, 0 },
  { "bgsit1", true, 98, 0, -1, -1, 0 },
  { "bgsit2", true, 98, 0, -1, -1, 0 },
  { "sgtsit", true, 98, 0, -1, -1, 0 },
  { "cacsit", true, 98, 0, -1, -1, 0 },
  { "brssit", true, 94, 0, -1, -1, 0 },
  { "cybsit", true, 92, 0, -1, -1, 0 },
  { "spisit", true, 90, 0, -1, -1, 0 },
  { "bspsit", true, 90, 0, -1, -1, 0 },
  { "kntsit", true, 90, 0, -1, -1, 0 },
  { "vilsit", true, 90, 0, -1, -1, 0 },
  { "mansit", true, 90, 0, -1, -1, 0 },
  { "pesit", true, 90, 0, -1, -1, 0 },
  { "sklatk", false, 70, 0, -1, -1, 0 },
  { "sgtatk", false, 70, 0, -1, -1, 0 },
  { "skepch", false, 70, 0, -1, -1, 0 },
  { "vilatk", false, 70, 0, -1, -1, 0 },
  { "claw", false, 70, 0, -1, -1, 0 },
  { "skeswg", false, 70, 0, -1, -1, 0 },
  { "pldeth", false, 32, 0, -1, -1, 0 },
  { "pdiehi", false, 32, 0, -1, -1, 0 },
  { "podth1", false, 70, 0, -1, -1, 0 },
  { "podth2", false, 70, 0, -1, -1, 0 },
  { "podth3", false, 70, 0, -1, -1, 0 },
  { "bgdth1", false, 70, 0, -1, -1, 0 },
  { "bgdth2", false, 70, 0, -1, -1, 0 },
  { "sgtdth", false, 70, 0, -1, -1, 0 },
  { "cacdth", false, 70, 0, -1, -1, 0 },
  { "skldth", false, 70, 0, -1, -1, 0 },
  { "brsdth", false, 32, 0, -1, -1, 0 },
  { "cybdth", false, 32, 0, -1, -1, 0 },
  { "spidth", false, 32, 0, -1, -1, 0 },
  { "bspdth", false, 32, 0, -1, -1, 0 },
  { "vildth", false, 32, 0, -1, -1, 0 },
  { "kntdth", false, 32, 0, -1, -1, 0 },
  { "pedth", false, 32, 0, -1, -1, 0 },
  { "skedth", false, 32, 0, -1, -1, 0 },
  { "posact", true, 120, 0, -1, -1, 0 },
  { "bgact", true, 120, 0, -1, -1, 0 },
  { "dmact", true, 120, 0, -1, -1, 0 },
  { "bspact", true, 100, 0, -1, -1, 0 },
  { "bspwlk", true, 100, 0, -1, -1, 0 },
  { "vilact", true, 100, 0, -1, -1, 0 },
  { "noway", false, 78, 0, -1, -1, 0 },
  { "barexp", false, 60, 0, -1, -1, 0 },
  { "punch", false, 64, 0, -1, -1, 0 },
  { "hoof", false, 70, 0, -1, -1, 0 },
  { "metal", false, 70, 0, -1, -1, 0 },
  { "pistol", false, 64, 0, -1, -1, 0 },
  { "tink", false, 60, 0, -1, -1, 0 },
  { "bdopn", false, 100, 0, -1, -1, 0 },
  { "bdcls", false, 100, 0, -1, -1, 0 },
  { "itmbk", false, 100, 0, -1, -1, 0 },
  { "flame", false, 32, 0, -1, -1, 0 },
  { "flamst", false, 32, 0, -1, -1, 0 },
  { "getpow", false, 60, 0, -1, -1, 0 },
  { "bospit", false, 70, 0, -1, -1, 0 },
  { "boscub", false, 70, 0, -1, -1, 0 },
  { "bossit", false, 70, 0, -1, -1, 0 },
  { "bospn", false, 70, 0, -1, -1, 0 },
  { "bosdth", false, 70, 0, -1, -1, 0 },
  { "manatk", false, 70, 0, -1, -1, 0 },
  { "mandth", false, 70, 0, -1, -1, 0 },
  { "sssit", false, 70, 0, -1, -1, 0 },
  { "ssdth", false, 70, 0, -1, -1, 0 },
  { "keenpn", false, 70, 0, -1, -1, 0 },
  { "keendt", false, 70, 0, -1, -1, 0 },
  { "skeact", false, 70, 0, -1, -1, 0 },
  { "skesit", false, 70, 0, -1, -1, 0 },
  { "skeatk", false, 70, 0, -1, -1, 0 },
  { "radio", false, 60, 0, -1, -1, 0 }
};

//Here is where Direct Sound comes in.

LPDIRECTSOUND		lpDS;
LPDIRECTSOUNDBUFFER     lpPrimary;
LPDIRECTSOUNDBUFFER     *lpChannels;
LPDIRECTSOUNDBUFFER     *lpSounds;
int DSNumChannels;
int *SoundNumOnChan;//give it the channel, it will tell you
                    //the buffer number.
int played=0;
int cachefail=0;
int DS_LoadSound(int num, void *data, int len);
int 		lengths[NUMSFX];//grab this during caching.

void DS_Init(int channels){

    int error,cnt;
    DSBUFFERDESC dsbd;
    WAVEFORMATEX wfm;

    Print("DS_Init:  Initializing DirectSound");
    DSNumChannels = channels;
    if(DSNumChannels <=0)
        DSNumChannels = 8;
    error = DirectSoundCreate(
    NULL,                   //Pick a Device, NULL == Default
    &lpDS,	                //The Handle;
    NULL);                  //Because. <Shrug>

    if(error != DS_OK && error != DSERR_NODRIVER)
        I_Error("Crappy, DirectSound Failure. %i",error);
    if(error == DSERR_NODRIVER){
        Print("No Sound Device Available.  Be vewwy vewwy Quiet.");
        lpDS=NULL;
        return;
    }

    error = IDirectSound_SetCooperativeLevel(lpDS,mainhwnd,DSSCL_EXCLUSIVE);
    if(error != DS_OK)
        I_Error("Crappy, DirectSound Failure.  SetCoopLevel.");

    lpChannels=malloc(DSNumChannels*sizeof(LPDIRECTSOUNDBUFFER));
    lpSounds=malloc((NUMSFX+DSNumChannels)*sizeof(LPDIRECTSOUNDBUFFER));
    SoundNumOnChan = malloc((DSNumChannels)*sizeof(int));

    dsbd.dwSize=sizeof(DSBUFFERDESC);

    dsbd.dwFlags=DSBCAPS_PRIMARYBUFFER;
    dsbd.dwBufferBytes=0;
    dsbd.dwReserved=0;
    dsbd.lpwfxFormat=NULL;
    error=IDirectSound_CreateSoundBuffer(lpDS,&dsbd,&lpPrimary,NULL);
    if(error !=DS_OK)
        I_Error("Crap, Primary Sound Buffer failed.");
    dsbd.dwFlags=DSBCAPS_CTRLDEFAULT|DSBCAPS_CTRLPOSITIONNOTIFY;

    wfm.wFormatTag=WAVE_FORMAT_PCM;
    wfm.nChannels=2;
    wfm.nSamplesPerSec=11025;
    wfm.nAvgBytesPerSec=11025*2*1;
    wfm.nBlockAlign=1;
    wfm.wBitsPerSample=8;
    wfm.cbSize=0;

    dsbd.lpwfxFormat=&wfm;
    dsbd.dwBufferBytes=DSBSIZE_MIN;
    IDirectSoundBuffer_SetFormat(lpPrimary,&wfm);
    //if(!lpChannels)
    //    I_Error("DirectSound, Unable to allocate channel pointers.");
    for(cnt=0;cnt<DSNumChannels;cnt++){
        lpChannels[cnt]=NULL;//for safty.
        SoundNumOnChan[cnt]=0;
    }
    for(cnt=0;cnt<NUMSFX+DSNumChannels;cnt++){
        lpSounds[cnt]=NULL;//for safty.
    }
    DS_CacheSound(0, SoundNumOnChan, DSNumChannels);
    //Print("Done init DS");
}
void DS_Stop(){
    int cnt;
    char mys[128];
    sprintf(mys,"DS_Stop:  Played %i sounds.",played);
    Print(mys);
    for(cnt=0;cnt<DSNumChannels+NUMSFX;cnt++){
        if(lpSounds[cnt]){
            IDirectSoundBuffer_Stop(lpSounds[cnt]);
            IDirectSoundBuffer_Release(lpSounds[cnt]);
            lpSounds[cnt] = NULL;
        }
    }
    if(lpPrimary){
        IDirectSoundBuffer_Stop(lpPrimary);
        IDirectSoundBuffer_Release(lpPrimary);
    }
    if(lpDS)
        IDirectSound_Release(lpDS);
    //Print("DS_Stop complete");

}
void DS_StopSoundChan(int chan){
    int snd=SoundNumOnChan[chan];
    //char mys[64];
    //sprintf(mys,"%i %i %i",NUMSFX,chan,snd);
    //Print("DS_StopChan");
    //Print(mys);
    //we delete the extra channels or the real one if the
    //cache failed.
    if((snd >=NUMSFX && lpSounds[snd]) ||(cachefail==1 && lpSounds[snd])){
        //Print("DS_Stop 1");
        IDirectSoundBuffer_Stop(lpSounds[snd]);
        IDirectSoundBuffer_Release(lpSounds[snd]);
        lpSounds[snd] = NULL;
    }
    else if (lpSounds[snd]){
        //Print("DS_Stop 2");
        IDirectSoundBuffer_Stop(lpSounds[snd]);
    }
    //Print("DS_Exit");
    SoundNumOnChan[chan]=0;
}

//The pan will be in Doom units.
//Conversion will take place here.
//pan == 128 is middle
//vol is doom.
//vol = 0 is silence.
//0 is full in DS and -10000 is silent.
void DS_StartSound(int chan, int snd, int pan, int vol){
    int error,status,cnt;
    char mys[64];
    pan = pan*(DSBPAN_RIGHT-DSBPAN_LEFT)/(1024) - DSBPAN_RIGHT/4;
    vol = vol*(+2000)/(128)-2000;//DirectSound Volume.

    played++;
    //If the cache failed then we didn't load the sound.
    //but if the sound is playing then it is here.
    //thus we don't want to load it on top of itself.
    //after this point, it will behave like normal.
    if(cachefail == 1 && lpSounds[snd]==NULL){
        error = DS_LoadSound(snd, S_sfx[snd].data, lengths[snd]);
        if(error)
            return;
    }

    IDirectSoundBuffer_GetStatus(lpSounds[snd],&status);
    //sprintf(mys,"Start, Status: %i %i %i",status&DSBSTATUS_PLAYING,chan,snd);
    //Print(mys);
    if(status&DSBSTATUS_PLAYING){//gotta clone it.
        error=IDirectSound_DuplicateSoundBuffer(lpDS,lpSounds[snd],&lpSounds[NUMSFX+chan]);
        if(error!=DS_OK)
            return;
        SoundNumOnChan[chan] = chan+NUMSFX;
        chan +=NUMSFX;
        error=IDirectSoundBuffer_SetCurrentPosition(lpSounds[chan],0);
        error=IDirectSoundBuffer_SetVolume(lpSounds[chan],vol);
        error=IDirectSoundBuffer_SetPan(lpSounds[chan],pan);
        error=IDirectSoundBuffer_Play(lpSounds[chan],0,0,NULL);
    }
    else{
        SoundNumOnChan[chan] = snd;
        error=IDirectSoundBuffer_SetCurrentPosition(lpSounds[snd],0);
        error=IDirectSoundBuffer_SetVolume(lpSounds[snd],vol);
        error=IDirectSoundBuffer_SetPan(lpSounds[snd],pan);
        error=IDirectSoundBuffer_Play(lpSounds[snd],0,0,NULL);
    }

}


//Returns play status.
int DS_SoundStatusChan(int chan){
    int status=0,error=0;
    int snd=SoundNumOnChan[chan];
    //char mys[64];
    //Print("DS_Status");
    if(lpSounds[snd])
        error = IDirectSoundBuffer_GetStatus(lpSounds[snd],&status);
    //sprintf(mys,"%i %i %i %i %i",error,status,chan,snd,lpSounds[snd]);
    //Print(mys);
    if(DSBSTATUS_PLAYING & status){
        //Print("Sound is on");
        return 1;
    }
    //Print("Sound is off");
    return 0;
}
//the sound moved.
void DS_UpdateSoundSettings(int chan, int pan, int vol){
    int error,cnt;
    int snd=SoundNumOnChan[chan];
    char mys[128],mys2[128];
    //sprintf(mys,"DS_Update pan: %i vol: %i",pan,vol);
    pan = pan*(DSBPAN_RIGHT-DSBPAN_LEFT)/(1024) - DSBPAN_RIGHT/4;
    vol = vol*(+2000)/(128)-2000;//DirectSound Volume.
    //sprintf(mys2,"%s pan: %i vol: %i",mys,pan,vol);
    //Print(mys2);
    if(lpSounds[snd]){
        //error=IDirectSoundBuffer_Stop(lpSounds[snd]);
        error=IDirectSoundBuffer_SetVolume(lpSounds[snd],vol);
        error=IDirectSoundBuffer_SetPan(lpSounds[snd],pan);
        error=IDirectSoundBuffer_Play(lpSounds[snd],0,0,NULL);
    }
}
void DS_PauseSound(int chan){
    int snd=SoundNumOnChan[chan];
    if(lpSounds[snd])
        IDirectSoundBuffer_Stop(lpSounds[snd]);
}

void DS_ResumeSound(int chan){
    int snd=SoundNumOnChan[chan];
    if(lpSounds[snd])
        IDirectSoundBuffer_Play(lpSounds[snd],0,0,NULL);
}

void DS_CacheSound(int num, void *data, int len){
    int error,cnt;
    DSBUFFERDESC dsbd;
    WAVEFORMATEX wfm;
    void *hand1,*hand2;
    int len1,len2;
    char mys[64];
    lengths[num]=len;//Save this in case the cache fails.
    //The length isn't available here.
    //The data pointer is available here.
    if(cachefail == 1) //don't cache
        return;

    wfm.wFormatTag=WAVE_FORMAT_PCM;
    wfm.nChannels=1;
    wfm.nSamplesPerSec=11025;
    wfm.nAvgBytesPerSec=11025*1*1;
    wfm.nBlockAlign=1;
    wfm.wBitsPerSample=8;
    wfm.cbSize=0;

    dsbd.dwSize=sizeof(DSBUFFERDESC);
    dsbd.dwReserved=0;
    dsbd.dwFlags=DSBCAPS_CTRLDEFAULT|DSBCAPS_CTRLPOSITIONNOTIFY|DSBCAPS_CTRLPAN;
    dsbd.lpwfxFormat=&wfm;
    dsbd.dwBufferBytes=len;

    error = IDirectSound_CreateSoundBuffer(lpDS,&dsbd, &lpSounds[num], NULL);
    if(error !=DS_OK){
        Print("Could not create DirectSound buffers.");
        sprintf(mys,"Sound num: %i name %s",num,S_sfx[num].name);
        Print(mys);
        Print("Will create buffers on a need-to-play basis.\ndah dah dah!");
        cachefail = 1;
        //Clear the cache, it doesn't work this way in cachefail
        //mode.  (I could let the sound die after its first use.)
        //But I don't know if that would free enough memory.
        Print("Removing sounds that have been cached.");
        for(cnt=0;cnt<DSNumChannels+NUMSFX;cnt++){
            if(lpSounds[cnt]){
                IDirectSoundBuffer_Stop(lpSounds[cnt]);
                IDirectSoundBuffer_Release(lpSounds[cnt]);
                lpSounds[cnt] = NULL;
            }
        }
        return;
    }
    error=IDirectSoundBuffer_SetCurrentPosition(lpSounds[num],0);
    error=IDirectSoundBuffer_Lock(lpSounds[num],0,len,&hand1,&len1,&hand2,&len2,0);
    memcpy(hand1,data,len);
    error=IDirectSoundBuffer_Unlock(lpSounds[num],hand1,len1,hand2,len2);
}
//Use this instead when cache mode to do sounds.
int DS_LoadSound(int num, void *data, int len){
    int error,cnt;
    DSBUFFERDESC dsbd;
    WAVEFORMATEX wfm;
    void *hand1,*hand2;
    int len1,len2;
    char mys[64];
    //Print("Loading sound");
    wfm.wFormatTag=WAVE_FORMAT_PCM;
    wfm.nChannels=1;
    wfm.nSamplesPerSec=11025;
    wfm.nAvgBytesPerSec=11025*1*1;
    wfm.nBlockAlign=1;
    wfm.wBitsPerSample=8;
    wfm.cbSize=0;

    dsbd.dwSize=sizeof(DSBUFFERDESC);
    dsbd.dwReserved=0;
    dsbd.dwFlags=DSBCAPS_CTRLDEFAULT|DSBCAPS_CTRLPOSITIONNOTIFY;
    dsbd.lpwfxFormat=&wfm;
    dsbd.dwBufferBytes=len;

    error = IDirectSound_CreateSoundBuffer(lpDS,&dsbd, &lpSounds[num], NULL);
    if(error !=DS_OK){
        Print("No play!");
        //crap!, well, just don't play it!
        return 1;
    }
    error=IDirectSoundBuffer_SetCurrentPosition(lpSounds[num],0);
    error=IDirectSoundBuffer_Lock(lpSounds[num],0,len,&hand1,&len1,&hand2,&len2,0);
    memcpy(hand1,data,len);
    error=IDirectSoundBuffer_Unlock(lpSounds[num],hand1,len1,hand2,len2);
    return 0;
}
